<template>
  <div>
    <h1 class="my-2">{{ $t("ProviderEdit.Photos") }}</h1>
    <v-divider class="my-2"></v-divider>
    <v-data-table
        :headers="headers"
        :items="getProvider.providerImages"
        hide-default-footer
        disable-filtering
        disable-pagination
        disable-sort
        class="flex-grow-1"
      >

        <template v-slot:[`item.url`]="{ item }">
          <v-dialog transition="dialog-top-transition" max-width="600">
            <template v-slot:activator="{ on, attrs }">
                <img height="80" class="my-2" :src="item.url" v-bind="attrs" v-on="on" />
            </template>
            <template v-slot:default="dialog">
              <v-card>
                <v-toolbar class="mygrad" dark>{{
                  $t("common.showPhoto")
                }}</v-toolbar>
                <v-card-text>
                  <v-img :src="item.url"> </v-img>
                </v-card-text>
                <v-card-actions class="justify-end">
                  <v-btn text @click="dialog.value = false">{{
                    $t("common.cancel")
                  }}</v-btn>
                </v-card-actions>
              </v-card>
            </template>
          </v-dialog>
        </template>
        <template v-slot:[`item.action`]="{ item }">
          <div class="actions">
            <!-- approve or disapprove image -->
            <!-- publishImage -->

            <v-dialog transition="dialog-top-transition" max-width="600">
              <template v-slot:activator="{ on, attrs }">
                <v-btn
              fab
              small
              dark
              class="mx-3 mygrad"
              v-bind="attrs"
                  v-on="on"
            >
              <v-icon class="mt-1 my-1">mdi-check-all</v-icon>
            </v-btn>
              </template>
              <template v-slot:default="dialog">
                <v-card>
                  <v-toolbar class="mygrad" dark>{{
                    $t("common.ApproveImage")
                  }}</v-toolbar>
                  <v-card-text class="py-2">
                    <v-img :src="item.url"> </v-img>
                  </v-card-text>
                  <v-card-actions class="justify-end">
                    <v-btn class="mygrad" dark @click="publishImage(item); dialog.value = false">
                      {{ $t("common.Approve") }}
                    </v-btn>
                    <v-btn text @click="dialog.value = false">{{
                      $t("common.cancel")
                    }}</v-btn>
                  </v-card-actions>
                </v-card>
              </template>
            </v-dialog>
            <!-- RejectPublishImage -->
            <v-dialog transition="dialog-top-transition" max-width="600">
              <template v-slot:activator="{ on, attrs }">
                <v-btn
                  v-bind="attrs"
                  v-on="on"
                  color="#E07979"
                  fab
                  small
                  dark
                  class="mx-3"
                >
                  <v-icon class="mt-1 my-1"
                    >mdi mdi-close-outline</v-icon
                  ></v-btn
                >
              </template>
              <template v-slot:default="dialog">
                <v-card>
                  <v-toolbar class="mygrad" dark>{{
                    $t("common.RejectImage")
                  }}</v-toolbar>
                  <v-card-text class="py-2">
                    <v-textarea
                      v-model="RejectReason"
                      rows="4"
                      prepend-icon="mdi-pen"
                      outlined
                      :label="$t('common.RejectReason')"
                    ></v-textarea>
                  </v-card-text>
                  <v-card-actions class="justify-end">
                    <v-btn color="#E07979" dark @click="RejectPublishImage(item) ; dialog.value = false">
                      {{ $t("common.Reject") }}
                    </v-btn>
                    <v-btn text @click="dialog.value = false">{{
                      $t("common.cancel")
                    }}</v-btn>
                  </v-card-actions>
                </v-card>
              </template>
            </v-dialog>
          </div>
        </template>
      </v-data-table>
  </div>
</template>
<script>
import { mapActions, mapGetters } from "vuex";
export default {
  name: "photos",
  data() {
    return {
      RejectReason: "",
      snack: false,
      snackColor: "",
      snackText: "",
      date: "",
      menu: false,
      isLoading: false,
      breadcrumbs: [
        {
          text: this.$i18n.t("menu.ManagePhotos"),
          disabled: false,
          href: "#",
        },
        {
          text: this.$i18n.t("menu.List"),
        },
      ],

      searchQuery: "",
      selectedUsers: [],
      headers: [


        { text: this.$i18n.t("provider.image"), value: "url" },
        {
          text: this.$i18n.t("provider.approve"),

          value: "action",
        },
      ],
    };
  },

  computed: {
    ...mapGetters("users", ["getProvider"]),
  },
  methods: {
    async publishImage(item) {
      this.isLoading = true;
      this.approveOrDisapproveImage({
        id: item.id,
        isActive: true,
      }).then((res) => {
        this.snack = true;
        this.snackColor = "success";
        this.snackText = res.data.message;
        this.isLoading = false;
      });
      this.fetchSingleProvider(this.$route.params.id);
    },
    RejectPublishImage(item) {
      this.isLoading = true;
      this.approveOrDisapproveImage({
        id: item.id,
        isActive: false,
        RejectReason: this.RejectReason,
      }).then(() => {
        this.snack = true;
        this.snackColor = "success";
        this.snackText = "Image has been Unapproved";
        this.isLoading = false;
        return Promise.resolve();
      });
      this.fetchSingleProvider(this.$route.params.id);
    },
    ...mapActions("users", ["fetchSingleProvider"]),
    ...mapActions("providerImages", [
      "approveOrDisapproveImage",
    ]),
    open() {},
  },
   mounted() {
    this.fetchSingleProvider(this.$route.params.id);
  },
}
</script>
